## ros-foxy-rmw-connext-cpp 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rmw_connext_cpp)

if(DEFINED ENV{CONNEXT_STATIC_DISABLE})
  set(disable_static_connext $ENV{CONNEXT_STATIC_DISABLE})
else()
  set(disable_static_connext FALSE)
endif()
set(CONNEXT_STATIC_DISABLE ${disable_static_connext}
  CACHE BOOL "If Connext Static should be disabled.")

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)

find_package(connext_cmake_module REQUIRED)
find_package(Connext QUIET MODULE)
if(Connext_FOUND)
  find_package(Connext MODULE)
endif()
if(NOT Connext_FOUND OR CONNEXT_STATIC_DISABLE)
  ament_package()
  if(NOT Connext_FOUND)
    message(WARNING "Could not find RTI Connext - skipping '${PROJECT_NAME}'")
  else()
    message(STATUS "Connext static rmw implementation explicitly disabled - skipping '${PROJECT_NAME}'")
  endif()
  return()
endif()

find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)

find_package(rosidl_typesupport_connext_c)
if(NOT rosidl_typesupport_connext_c_FOUND)
  ament_package()
  message(WARNING "Could not find ROSIDL TypeSupport for Connext (rosidl_typesupport_connext_c) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rosidl_typesupport_connext_cpp)
if(NOT rosidl_typesupport_connext_cpp_FOUND)
  ament_package()
  message(WARNING "Could not find ROSIDL TypeSupport for Connext (rosidl_typesupport_connext_cpp) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rmw REQUIRED)
find_package(rmw_connext_shared_cpp REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(rosidl_runtime_cpp REQUIRED)

include_directories(include)

ament_export_include_directories(include)
ament_export_dependencies(
  rcpputils
  rcutils
  rmw
  rmw_connext_shared_cpp
  rosidl_runtime_c
  rosidl_runtime_cpp
  rosidl_typesupport_connext_c
  rosidl_typesupport_connext_cpp)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_connext_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_connext_cpp"
)

# generate code for raw data
set(generated_directory "${CMAKE_CURRENT_BINARY_DIR}/resources/generated")
file(MAKE_DIRECTORY ${generated_directory})
set(generated_files
  ${generated_directory}/connext_static_serialized_data.cxx
  ${generated_directory}/connext_static_serialized_data.h
  ${generated_directory}/connext_static_serialized_dataPlugin.cxx
  ${generated_directory}/connext_static_serialized_dataPlugin.h
  ${generated_directory}/connext_static_serialized_dataSupport.cxx
  ${generated_directory}/connext_static_serialized_dataSupport.h
)
add_custom_command(
  OUTPUT ${generated_files}
  # We *explicitly* do not use Connext_DDSGEN_SERVER here.  The other time we invoke the
  # server is in rosidl_typesupport_connext_cpp, and that uses a different set of arguments.
  # We don't want to accidentally connect to that other version of the server that might
  # still be running.
  COMMAND ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/bin/call-idl-pp.py" --idl-pp "${Connext_DDSGEN}" --idl-file "connext_static_serialized_data.idl" -d ${generated_directory}
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/resources"
  COMMENT "Generating serialized type support for RTI Connext (using '${Connext_DDSGEN}')"
  VERBATIM
)

# determine major version of Connext
find_file(connext_version_header "ndds_version.h"
  PATHS ${Connext_INCLUDE_DIRS}
  PATH_SUFFIXES "ndds"
  NO_DEFAULT_PATH)
if(NOT connext_version_header)
  message(FATAL_ERROR "Failed to find 'ndds/ndds_version.h' in '${Connext_INCLUDE_DIRS}'")
endif()
file(STRINGS "${connext_version_header}" connext_define_major_version LIMIT_COUNT 1 REGEX "#define RTI_DDS_VERSION_MAJOR  [0-9]+")
if("${connext_define_major_version}" STREQUAL "")
  message(FATAL_ERROR "Failed to find '#define RTI_DDS_VERSION_MAJOR' in '${connext_version_header}'")
endif()
string(REGEX REPLACE ".* ([0-9]+)" "\\1" connext_major_version "${connext_define_major_version}")

# patch the generate code for raw data
if("${connext_major_version}" LESS 6)
  set(patch_files_subdirectory "patch_files")
else()
  set(patch_files_subdirectory "patch_files_v6")
endif()
set(patch_files
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_data.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_data.h.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataPlugin.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataPlugin.h.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataSupport.cxx.patch
  ${CMAKE_CURRENT_SOURCE_DIR}/resources/${patch_files_subdirectory}/connext_static_serialized_dataSupport.h.patch
)
set(patched_directory "${CMAKE_CURRENT_BINARY_DIR}/resources/patched")
file(MAKE_DIRECTORY ${patched_directory})
set(patched_files
  ${patched_directory}/connext_static_serialized_data.cxx
  ${patched_directory}/connext_static_serialized_data.h
  ${patched_directory}/connext_static_serialized_dataPlugin.cxx
  ${patched_directory}/connext_static_serialized_dataPlugin.h
  ${patched_directory}/connext_static_serialized_dataSupport.cxx
  ${patched_directory}/connext_static_serialized_dataSupport.h
)
add_custom_command(
  OUTPUT ${patched_files}
  COMMAND ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/bin/apply-patch.py" --input ${generated_files} --patch ${patch_files} --out ${patched_files}
  DEPENDS ${generated_files}
  COMMENT "Patching serialized type support for RTI Connext"
  VERBATIM
)

add_library(
  rmw_connext_cpp
  SHARED
  ${patched_files}
  src/connext_static_publisher_info.cpp
  src/connext_static_subscriber_info.cpp
  src/get_client.cpp
  src/get_participant.cpp
  src/get_publisher.cpp
  src/get_service.cpp
  src/get_subscriber.cpp
  src/identifier.cpp
  src/process_topic_and_service_names.cpp
  src/rmw_client.cpp
  src/rmw_compare_gid_equals.cpp
  src/rmw_count.cpp
  src/rmw_event.cpp
  src/rmw_get_gid_for_publisher.cpp
  src/rmw_get_implementation_identifier.cpp
  src/rmw_get_serialization_format.cpp
  src/rmw_guard_condition.cpp
  src/rmw_init.cpp
  src/rmw_logging.cpp
  src/rmw_node.cpp
  src/rmw_node_info_and_types.cpp
  src/rmw_node_names.cpp
  src/rmw_publish.cpp
  src/rmw_publisher.cpp
  src/rmw_request.cpp
  src/rmw_response.cpp
  src/rmw_serialize.cpp
  src/rmw_service.cpp
  src/rmw_service_names_and_types.cpp
  src/rmw_service_server_is_available.cpp
  src/rmw_subscription.cpp
  src/rmw_take.cpp
  src/rmw_topic_names_and_types.cpp
  src/rmw_trigger_guard_condition.cpp
  src/rmw_wait.cpp
  src/rmw_wait_set.cpp
  src/serialization_format.cpp
  src/rmw_get_topic_endpoint_info.cpp)
ament_target_dependencies(rmw_connext_cpp
  "rcpputils"
  "rcutils"
  "rmw"
  "rmw_connext_shared_cpp"
  "rosidl_runtime_c"
  "rosidl_runtime_cpp"
  "rosidl_typesupport_connext_c"
  "rosidl_typesupport_connext_cpp"
  "Connext")
target_include_directories(rmw_connext_cpp PUBLIC ${patched_directory})
ament_export_libraries(rmw_connext_cpp)

# Causes the visibility macros to use dllexport rather than dllimport
# which is appropriate when building the library but not consuming it.
target_compile_definitions(rmw_connext_cpp
  PRIVATE "RMW_CONNEXT_CPP_BUILDING_DLL")

# On Windows this adds the RMW_BUILDING_DLL definition.
# On Unix (GCC or Clang) it hides the symbols with -fvisibility=hidden.
configure_rmw_library(rmw_connext_cpp)

if(WIN32)
  target_compile_definitions(rmw_connext_cpp
    PRIVATE "_CRT_NONSTDC_NO_DEPRECATE")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package(CONFIG_EXTRAS "${PROJECT_NAME}-extras.cmake")

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS rmw_connext_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

get_rmw_connext_output_filter("rmw_connext_output_filter")
ament_index_register_resource("rmw_output_prefixes" CONTENT "${rmw_connext_output_filter}")

=== debian/changelog ===
ros-foxy-rmw-connext-cpp (1.0.3-1focal) focal; urgency=high

  * Fix wrong error messages (#458 <https://github.com/ros2/rmw_connext/issues/458>) (#478 <https://github.com/ros2/rmw_connext/issues/478>)
  * Update maintainers (#468 <https://github.com/ros2/rmw_connext/issues/468>) (#470 <https://github.com/ros2/rmw_connext/issues/470>)
  * Contributors: Alejandro Hernández Cordero, Ivan Santiago Paunovic

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Tue, 08 Dec 2020 08:00:00 -0000

ros-foxy-rmw-connext-cpp (1.0.2-1focal) focal; urgency=high

  * Return RMW_RET_UNSUPPORTED in rmw_get_serialized_message_size (#467 <https://github.com/ros2/rmw_connext/issues/467>)
  * returned RMW_RET_INCORRECT_RMW_IMPLEMENTATION in rmw_service_server_is_available (#466 <https://github.com/ros2/rmw_connext/issues/466>)
  * Update service/client request/response API error returns (#465 <https://github.com/ros2/rmw_connext/issues/465>)
  * Updated rmw_* return codes (#463 <https://github.com/ros2/rmw_connext/issues/463>)
  * Update service/client construction/destruction API return codes. (#464 <https://github.com/ros2/rmw_connext/issues/464>)
  * Updated returns on rmw_take_serialized_with_info (#462 <https://github.com/ros2/rmw_connext/issues/462>)
  * Update gid API return codes. (#461 <https://github.com/ros2/rmw_connext/issues/461>)
  * updated error returns (#456 <https://github.com/ros2/rmw_connext/issues/456>)
  * Updated error returns on rmw_take (#454 <https://github.com/ros2/rmw_connext/issues/454>)
  * Update rmw_publish() error returns (#452 <https://github.com/ros2/rmw_connext/issues/452>)
  * Update rmw_publish_serialized_message() error returns (#453 <https://github.com/ros2/rmw_connext/issues/453>)
  * Ensure compliant matched pub/sub count API. (#451 <https://github.com/ros2/rmw_connext/issues/451>)
  * Ensure compliant subscription API. (#450 <https://github.com/ros2/rmw_connext/issues/450>)
  * Decouple rmw_destroy_publisher() outcome from global RMW error state. (#449 <https://github.com/ros2/rmw_connext/issues/449>)
  * Ensure compliant publisher API (#445 <https://github.com/ros2/rmw_connext/issues/445>)
  * Ensure compliant node construction/destruction API. (#439 <https://github.com/ros2/rmw_connext/issues/439>)
  * Amend rmw_init() implementation: require enclave. (#437 <https://github.com/ros2/rmw_connext/issues/437>)
  * Ensure compliant init/shutdown API implementation. (#432 <https://github.com/ros2/rmw_connext/issues/432>)
  * Ensure compliant init options API implementations. (#431 <https://github.com/ros2/rmw_connext/issues/431>)
  * Finalize context if and only if it's shutdown (#428 <https://github.com/ros2/rmw_connext/issues/428>)
  * Contributors: Alejandro Hernández Cordero, Jose Tomas Lorente, Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 15 Oct 2020 07:00:00 -0000

ros-foxy-rmw-connext-cpp (1.0.1-1focal) focal; urgency=high



 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 07 Jul 2020 07:00:00 -0000

ros-foxy-rmw-connext-cpp (1.0.0-1focal) focal; urgency=high

  * Remove MANUAL_BY_NODE liveliness API (#423 <https://github.com/ros2/rmw_connext/issues/423>)
  * Contributors: Ivan Santiago Paunovic

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 12 May 2020 07:00:00 -0000

ros-foxy-rmw-connext-cpp (0.9.1-1focal) focal; urgency=high

  * Correct rmw_take() return value. (#419 <https://github.com/ros2/rmw_connext/issues/419>)
  * Switch to always using rtiddsgen (not the server). (#421 <https://github.com/ros2/rmw_connext/issues/421>)
  * Cast to size_t before doing comparison (#420 <https://github.com/ros2/rmw_connext/issues/420>)
  * Cast size_t to DDS_Long explicitly. (#416 <https://github.com/ros2/rmw_connext/issues/416>)
  * set connext buffer capacity (#417 <https://github.com/ros2/rmw_connext/issues/417>)
  * Retry calling the idl_pp up to 10 times. (#415 <https://github.com/ros2/rmw_connext/issues/415>)
  * Contributors: Chris Lalancette, Karsten Knese, Michel Hidalgo, Shane Loretz

 -- Dirk Thomas <dthomas@osrfoundation.org>  Fri, 08 May 2020 07:00:00 -0000

ros-foxy-rmw-connext-cpp (0.9.0-1focal) focal; urgency=high

  * Rename rosidl_message_bounds_t (#413 <https://github.com/ros2/rmw_connext/issues/413>)
  * More verbose error output when apply_patch.py fails (#414 <https://github.com/ros2/rmw_connext/issues/414>)
  * Switch take_response and take_request to rmw_service_info_t (#412 <https://github.com/ros2/rmw_connext/issues/412>)
  * Add support for taking a sequence of messages (#408 <https://github.com/ros2/rmw_connext/issues/408>)
  * Fix CMake warning about using uninitialized variables (#411 <https://github.com/ros2/rmw_connext/issues/411>)
  * security-context -> enclave (#407 <https://github.com/ros2/rmw_connext/issues/407>)
  * Replace rosidl_generator_x for rosidl_runtime_x (#399 <https://github.com/ros2/rmw_connext/issues/399>)
  * API changes to sync with one Participant per Context change in rmw_fastrtps (#392 <https://github.com/ros2/rmw_connext/issues/392>)
  * Support for ON_REQUESTED_INCOMPATIBLE_QOS and ON_OFFERED_INCOMPATIBLE_QOS events (#398 <https://github.com/ros2/rmw_connext/issues/398>)
  * Add rmw_*_event_init() functions (#397 <https://github.com/ros2/rmw_connext/issues/397>)
  * Fix build warnings due to -Wsign-compare with GCC 9 (#396 <https://github.com/ros2/rmw_connext/issues/396>)
  * Implement the rmw_get_publishers/subscriptions_info_by_topic() methods (#391 <https://github.com/ros2/rmw_connext/issues/391>)
  * Finding rmw_connext_shared_cpp must succeed, only rmw_connext_cpp can signal not-found when Connext is not available (#389 <https://github.com/ros2/rmw_connext/issues/389>)
  * Code style only: wrap after open parenthesis if not in one line (#387 <https://github.com/ros2/rmw_connext/issues/387>)
  * Avoid using build time Connext library paths, determine them when downstream packages are built (#385 <https://github.com/ros2/rmw_connext/issues/385>)


=== debian/control ===
Source: ros-foxy-rmw-connext-cpp
Section: misc
Priority: optional
Maintainer: Alejandro Hernandez Cordero <alejandro@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-connext-cmake-module, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-connext-shared-cpp, ros-foxy-rosidl-cmake, ros-foxy-rosidl-generator-dds-idl, ros-foxy-rosidl-runtime-c, ros-foxy-rosidl-runtime-cpp, ros-foxy-rosidl-typesupport-connext-c, ros-foxy-rosidl-typesupport-connext-cpp, rti-connext-dds-5.3.1, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rmw-connext-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-cmake, ros-foxy-connext-cmake-module, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-connext-shared-cpp, ros-foxy-rosidl-cmake, ros-foxy-rosidl-runtime-c, ros-foxy-rosidl-runtime-cpp, ros-foxy-rosidl-typesupport-connext-c, ros-foxy-rosidl-typesupport-connext-cpp, rti-connext-dds-5.3.1, ros-foxy-ros-workspace
Description: Implement the ROS middleware interface using RTI Connext static code generation in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rmw-connext-cpp//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
